module x2f_mpi_grpdata
!
!
! Store the important datas used in adaptive strategies:
!   grp_index  - indicate which group the processor belongs to
!       g      - number of processors in each group 
!      ng      - number of groups in each partition
!   pt_index   - indicate which partition the processor belongs to
!   mpicomm_pt - the communicator used within partition
!   intracomm  - the communicator used within group
!      ips     - the i-th pairing stage
!      mps     - total number of pairing stage
!   pairstg    - pairing stage or not
!
implicit none
integer, save        :: grp_index, g, ng, pt_index, mpicomm_pt
integer, save        :: intracomm, intercomm, ips, mps
real, save           :: t_C
logical, save        :: pairstg

end module x2f_mpi_grpdata
